#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "external.h"

extern int temp[2][MAX_LEN];


double ga_pair_um(int no_res1,int no_res2,double **mat2,int *len,
		  double gap_pen){



register int jj,kk,i,l;
int m,n;
int ii;
double sigma;
double dum1,dum2,gap0max;
double score;



/* Allocate memory for matrices of lengths of each

	      2 sequences + 1 */

gap2=dmatrix(0,no_res1,0,no_res2);

gap1=dmatrix(0,no_res1,0,no_res2);

gap0=dmatrix(0,no_res1,0,no_res2);


/* Initialise matrices */

for(j=0;j<=no_res1;++j){

   gap2[j][0]=gap1[j][0]=gap0[j][0]=0.0;

}
	for(k=0;k<=no_res2;++k){

	    gap2[0][k]=gap1[0][k]=gap0[0][k]=0.0;

	}

/* Score all possible residue matches */

for(j=1;j<=no_res1;++j){

    jj=j-1;

    for(k=1;k<=no_res2;++k){

	kk=k-1;

	/* j-1,k-1 because mat2 is 0 to len-1 */

	sigma=mat2[j-1][k-1];


        /******** Determine gap0[j][k] ********/


	gap0max=gap0[jj][kk];

	dum1=gap2[jj][kk]-gap_pen;

	dum2=gap1[jj][kk]-gap_pen;

	if(gap0max < dum1){

	  gap0max=dum1;

	}

        if(gap0max < dum2){

	  gap0max=dum2;

	}

	gap0[j][k]=gap0max + sigma;


        /******** Determine gap2[j][k] ********/


	gap2[j][k]=gap2[jj][k];

	if(gap2[jj][k] < gap0[jj][k]){

	   gap2[j][k]=gap0[jj][k];

	}

	/******** Determine gap1[j][k] ********/


	gap1[j][k]=gap1[j][kk];
	

	if(gap1[j][kk] < gap0[j][kk]){

	   gap1[j][k]=gap0[j][kk];

	}
   }

}

/* Locate high edge value */

m=no_res1;

n=no_res2;

score=gap1[m][n];

if(score < gap2[m][n]){

  score=gap2[m][n];

}

  if(score < gap0[m][n]){

    score=gap0[m][n];

  }

  /* Start recursion... */

  j=m;
  k=n;
  c=0;

if(score==gap0[j][k]){

	     align[0][c] = j;
	     align[1][c] = k;
	     c++;
	     ga_gap0_trace(gap_pen);
}


else if(score==gap2[j][k]){

	     align[0][c] = j;
	     align[1][c] = (-99);
	     c++;
	     ga_gap2_trace(gap_pen);
}


     else{	

	     align[0][c] = (-99);
	     align[1][c] = k;
	     c++;
	     ga_gap1_trace(gap_pen);
     }


  /* Fill in the beginning of alignment */

  if(j==1){

	   while(k>1){

		      align[0][c] = (-99);
		      align[1][c++] = (--k);

		      if(c>=MAX_LEN){
			fprintf(stderr,"Too many residues in alignment!!\n");
			exit(1);
		      }
	   }
  }

  if(k==1){

	   while(j>1){

		      align[0][c] = (--j);
		      align[1][c++] = (-99);

		      if(c>=MAX_LEN){
			fprintf(stderr,"Too many residues in alignment!!\n");
			exit(1);
		      }
	   }
  }

/* Record length of alignment */

*len= c;

/* Update temp[2][len] */

ii=1; /* temp starts at 1 */

for(i=c-1; i>=0; i--){  /* c starts at 0 */

   temp[0][ii] = align[0][i];
   temp[1][ii] = align[1][i];

   ii++;
}


free_dmatrix(gap2,0,no_res1,0,no_res2);
free_dmatrix(gap1,0,no_res1,0,no_res2);
free_dmatrix(gap0,0,no_res1,0,no_res2);


/* Successful return value */

return (score);
}

/******** ga_gap0_trace() ********/

void ga_gap0_trace(double gap_pen){

double gap0_max;

if(j==1||k==1)
  return;

j--;
k--;

gap0_max = gap0[j][k];

if(gap0_max < gap2[j][k] - gap_pen){

   gap0_max=gap2[j][k] - gap_pen;

}

if(gap0_max < gap1[j][k] - gap_pen){

   gap0_max=gap1[j][k] - gap_pen;

}

if(gap0_max == gap0[j][k]){

	     align[0][c] = j;
	     align[1][c] = k;
	     c++;
	     if(c>=MAX_LEN){
		fprintf(stderr,"\n Too many residues in alignment!");
		exit(1);
	     }
	     ga_gap0_trace(gap_pen);
	     return;
}


else if(gap0_max == (gap2[j][k]-gap_pen)){

	     align[0][c] = j;
	     align[1][c] = (-99);
	     c++;
	     if(c>=MAX_LEN){
		fprintf(stderr,"\n Too many residues in alignment!");
		exit(1);
	     }
	     ga_gap2_trace(gap_pen);
	     return;
}
     else{

	     align[0][c] = (-99);
	     align[1][c] = k;
	     c++;
	     if(c>=MAX_LEN){
		fprintf(stderr,"\n Too many residues in alignment!");
		exit(1);
	     }
	     ga_gap1_trace(gap_pen);
	     return;
     }
}

/******** ga_gap2_trace() ********/

void ga_gap2_trace(double gap_pen){

if(j==1)
  return;

j--;
align[0][c] = j;

  if(gap2[j][k] > gap0[j][k]){

    align[1][c] = (-99);
    c++;
    if(c>=MAX_LEN){
       fprintf(stderr,"\n Too many residues in alignment!");
       exit(1);
    }
    ga_gap2_trace(gap_pen);
    return;
  }
  else{

      align[1][c] = k;
      c++;
      if(c>=MAX_LEN){
         fprintf(stderr,"\n Too many residues in alignment!");
         exit(1);
      }
      ga_gap0_trace(gap_pen);
      return;
  }
}

/******** ga_gap1_trace() ********/

void ga_gap1_trace(double gap_pen){

if(k==1)
  return;

k--;
align[1][c] = k;

  if(gap1[j][k] > gap0[j][k]){

    align[0][c] = (-99);
    c++;
    if(c>=MAX_LEN){
       fprintf(stderr,"\n Too many residues in alignment!");
       exit(1);
    }
    ga_gap1_trace(gap_pen);
    return;
  }
  else{

      align[0][c] = j;
      c++;
      if(c>=MAX_LEN){
         fprintf(stderr,"\n Too many residues in alignment!");
         exit(1);
      }
      ga_gap0_trace(gap_pen);
      return;
  }
}








	

	
