#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "external.h"

extern char seq[MAX_SEQ][MAX_LEN];
extern int temp[2][MAX_LEN];
extern int mats[11][20][20];
extern int ind[26];
extern float largest_dim[MAX_SEQ];
extern int len[MAX_SEQ];
extern int ren[MAX_SEQ];
int Kears_final_equiv[2][(MAX_LEN-52)];
int final_equiv[2][(MAX_LEN-52)];



int bits2int(int *string,int len){

    int i;
    int accum=0;
    int powerof2=1;


    for(i=len-1;i>=0;i--){
    
       if(string[i])
	 accum+=powerof2;

       powerof2*=2;
    }

return accum;
}

/******** Prints the global best individual so far rmsd and

	  number of CA-CA distances less than cut_off distance

	  for equivalences ********/


/* Alex May 30-09-93 */

int print_align_ca(int no_res1, int no_res2, int list1[MAX_SEQ], int nlist1,
		   int list2[MAX_SEQ], int nlist2, double **mat1, int len,
		   double sqr_cutoff,int *end_no_bestca){


int i,j,k,m,p,q;
int last_j, last_k;
int *check1, *check2;
int *last_check1, *last_check2;
int no_ca=0;
int no_bestca=0;	/* GA-matched equivalences */
double total_dist=0.0;
double rmsd1,rmsd2,rmsd3;
int equiv[2][(MAX_LEN-52)];
float avg_ca[2][(MAX_LEN-52)][3];
float fragment_centroid[2][3];
float equiv_ca[2][(MAX_LEN-52)][3];

int nrot;
float xp, yp, zp, xm, ym, zm;
float **mat,**evec,*eval;
float q1,q2,q3,q4;
double rot[3][3]; /* rotation matrix */
float vtrans[3]; /* translation vector */
float temp[3];
float new_ca[(MAX_LEN-52)][3];
float temp_ca[MAX_SEQ][(MAX_LEN-52)][3];
float total_xyz[MAX_SEQ][3] = {0.0};
float centroid[MAX_SEQ][3];
double d;



/* allocate storage for calculation of eigenvectors and eigenvalues */

mat=fmatrix(1,4,1,4);
evec=fmatrix(1,4,1,4);
eval=vector(1,4);

/* zero arrays */

for (i=1; i<5; i++)
	for (j=1; j<5; j++)
		mat[i][j]=0.0;


for (i=0; i<2; i++)
	for (j=0; j<3; j++)
		fragment_centroid[i][j]= 0.0;

printf(" Best CA-CA alignment data at finish: \n");
printf(" -----------------------------------\n");

printf("\n Topological equivalences after Genetic Algorithm: ");
printf("\n ------------------------------------------------\n");


m=0;

last_j = 0;
last_k = 0;

/* Allocate memory for checks on lengths */

check1 = ivector(0, nlist1-1);
last_check1 = ivector(0, nlist1-1);

check2 = ivector(0, nlist2-1);
last_check2 = ivector(0, nlist2-1);

/* zero arrays */

for(i=0; i<nlist1; i++){
   check1[i] = 0;
   last_check1[i] = 0;
}

for(i=0; i<nlist2; i++){
   check2[i] = 0;
   last_check2[i] = 0;
}


for(i=len-1;i>=0;i--){

   /*printf("\nCheck i = %d \tlen = %d",i,len);*/

   /* Test for no gap in list1 proteins */

   if(align[0][i]!=(-99))
     j = align[0][i];

   /*printf("\nCheck align[0][%d] = %d",i,align[0][i]);*/

     /* Test for no gap in list2 proteins */

     if(align[1][i]!=(-99))
       k = align[1][i];

     /*printf("\nCheck align[1][%d] = %d",i,align[1][i]);*/

       /* Test for corresponding atoms in list1 and list2 proteins */

       if((align[0][i]!=(-99)) && (align[1][i]!=(-99))){

	   if((no_ca<=no_res1)&&(no_ca<=no_res2)){
	     no_ca++;
	   }

           else{

	     fprintf(stderr,"Error in print_align_ca() at generation %d\n",gen);
	     fprintf(stderr,"no_ca=%d in print_align_ca()\n",no_ca);
	     exit(1);
	   }

	    /* Test for defined distance apart */

	    /* j-1,k-1 because mat1 is 0 to len-1 */

	    if((mat1[j-1][k-1] < sqr_cutoff )&&(no_bestca<=no_ca)){

	      total_dist+=mat1[j-1][k-1];

	      no_bestca++; /* GA-matched equivalence */

	      printf("\n %d		 [",no_bestca);

	      for(p=last_j; p<j; p++){
		 for(q=0; q<nlist1; q++){

		    if(seq[list1[q]][p+1] != '-')
		      check1[q]++;
		 }
	      }
	      last_j = j; /* Update */

	      for(q=0; q<nlist1; q++){

		 if(check1[q]<=ren[list1[q]]){

		   if(q == (nlist1-1)){
		     if((check1[q]>0) && (check1[q]>last_check1[q]) && (seq[list1[q]][j] != '-'))
		       printf("%s %s",residue_number[list1[q]][check1[q] - 1],residue_name[list1[q]][check1[q] - 1]);
		     else
		       printf("        ");
		   }
		   else{
		     if((check1[q]>0) && (check1[q]>last_check1[q]) && (seq[list1[q]][j] != '-'))
		       printf("%s %s-",residue_number[list1[q]][check1[q] - 1],residue_name[list1[q]][check1[q] - 1]);
		     else
		       printf("        -");
		   }
		 }
		 else{

		   if(q == (nlist1-1))
		     printf("        ");

		   else
		     printf("        -");
		 }

		 last_check1[q] = check1[q]; /* Update */
	      }

	      printf("]");
	      printf("          [");

	      for(p=last_k; p<k; p++){
		 for(q=0; q<nlist2; q++){

		    if(seq[list2[q]][p+1] != '-')
		      check2[q]++;
		 }
	      }
	      last_k = k; /* Update */

	      for(q=0; q<nlist2; q++){

		 if(check2[q]<=ren[list2[q]]){

		   if(q == (nlist2-1)){
		     if((check2[q]>0) && (check2[q]>last_check2[q]) && (seq[list2[q]][j] != '-'))
		       printf("%s %s",residue_number[list2[q]][check2[q] - 1],residue_name[list2[q]][check2[q] - 1]);
		     else
		       printf("        ");
		   }
		   else{
		     if((check2[q]>0) && (check2[q]>last_check2[q]) && (seq[list2[q]][j] != '-'))
		       printf("%s %s-",residue_number[list2[q]][check2[q] - 1],residue_name[list2[q]][check2[q] - 1]);
		     else
		       printf("        -");
		   }
		 }
		 else{

		   if(q == (nlist2-1))
		     printf("        ");

		   else
		     printf("        -");
		 }

		 last_check2[q] = check2[q]; /* Update */
	      }

	      printf("]");
	      printf("            %0.3f",sqrt(mat1[j-1][k-1]));

	      equiv[0][m] = (j-1);
	      equiv[1][m] = (k-1);

	      m++;

	      if(m >= (MAX_LEN-52)){
		fprintf(stderr,"Too many equivalences!!\n");
	        exit(1);
	      }
	    }
       }
}

/* zero avg_ca[0] array for list1 proteins */

for(i=0; i<no_res1; i++)
       for (j=0; j<3; j++)
	       avg_ca[0][i][j] = 0.0;

/* zero array */

for(i=0; i<nlist1; i++)
   check1[i] = 0;


/* calculate the average starting coordinates for list1 proteins :
   first fragment */

for(i=0; i<no_res1; i++){

   m=0;

   for(j=0; j<nlist1; j++){

      if(seq[list1[j]][i+1] != '-'){

	check1[j]++;

	if(check1[j] > ren[list1[j]]){
	  fprintf(stderr,"Error : check1 in print_align_ca()\n");
	  exit(1);
	}

	m++; /* increment counter */

	for (k=0; k<3; k++)
	    avg_ca[0][i][k] += start_ca[list1[j]][check1[j] - 1][k];

      }
   }
   /* Average at position i */

   if(m == 0){
     fprintf(stderr,"Error calculating avg. starting coords. for list1 proteins\n");
     fprintf(stderr,"m == 0\n");
     fprintf(stderr,"no_res1 == %d\n",no_res1);
     fprintf(stderr,"nlist1 == %d\n",nlist1);
     exit(1);
   }
   else{

     for (k=0; k<3; k++)
	 avg_ca[0][i][k] /= (float)m;

   }
}

/* zero avg_ca[1] array for list2 proteins */

for(i=0; i<no_res2; i++)
       for (j=0; j<3; j++)
	       avg_ca[1][i][j] = 0.0;

/* zero array */

for(i=0; i<nlist2; i++)
   check2[i] = 0;



/* calculate the average starting coordinates for list2 proteins :
   second fragment */

for(i=0; i<no_res2; i++){

   m=0;

   for(j=0; j<nlist2; j++){

      if(seq[list2[j]][i+1] != '-'){

	check2[j]++;

	if(check2[j] > ren[list2[j]]){
	  fprintf(stderr,"Error : check2 in print_align_ca()\n");
	  exit(1);
	}

	m++; /* increment counter */

	for (k=0; k<3; k++)
	    avg_ca[1][i][k] += start_ca[list2[j]][check2[j] - 1][k];

      }
   }
   /* Average at position i */

   if(m == 0){
     fprintf(stderr,"Error calculating avg. starting coords. for list2 proteins\n");
     fprintf(stderr,"m == 0\n");
     fprintf(stderr,"no_res2 == %d\n",no_res2);
     fprintf(stderr,"nlist2 == %d\n",nlist2);
     exit(1);
   }
   else{

     for (k=0; k<3; k++)
	 avg_ca[1][i][k] /= (float)m;

   }
}


/* calculate the centroid of each fragment */

for (k=0; k<2; k++)
	for (i=0; i<no_bestca; i++)
		for (j=0; j<3; j++)
			fragment_centroid[k][j]+=avg_ca[k][equiv[k][i]][j];

for (k=0; k<2; k++)
	for (i=0; i<3; i++)
		fragment_centroid[k][i]/=no_bestca;

/* mean-centre the co-ordinates of each fragment */

for(k=0;k<2;k++)
    for (i=0; i<no_bestca; i++)
	for (j=0; j<3; j++){
	    equiv_ca[k][i][j] = avg_ca[k][equiv[k][i]][j]

				- fragment_centroid[k][j];

	}

for (i=0; i<no_bestca; i++){


	   /* Kearsley least-squares fitting */

	   /* calculate sums and differences of corresponding co-ordinates */

	   xp = equiv_ca[0][i][0] + equiv_ca[1][i][0];
	   yp = equiv_ca[0][i][1] + equiv_ca[1][i][1];
	   zp = equiv_ca[0][i][2] + equiv_ca[1][i][2];

	   xm = equiv_ca[0][i][0] - equiv_ca[1][i][0];
	   ym = equiv_ca[0][i][1] - equiv_ca[1][i][1];
	   zm = equiv_ca[0][i][2] - equiv_ca[1][i][2];

	   /* set up matrix to be diagonalized */

	   mat[1][1] += xm*xm + ym*ym + zm*zm;
	   mat[1][2] += yp*zm - ym*zp;
	   mat[1][3] += xm*zp - xp*zm;
	   mat[1][4] += xp*ym - xm*yp;

	   mat[2][2] += yp*yp + zp*zp + xm*xm;
	   mat[2][3] += xm*ym - xp*yp;
	   mat[2][4] += xm*zm - xp*zp;

	   mat[3][3] += xp*xp + zp*zp + ym*ym;
	   mat[3][4] += ym*zm - yp*zp;

	   mat[4][4] += xp*xp + yp*yp + zm*zm;
}


/* fill in the lower triangle of mat */

for (i=2; i<5; i++)
	for (j=1; j<i; j++)
		mat[i][j] = mat[j][i];

/* calculate eigenvectors and eigenvalues of mat */

jacobi(mat,4,eval,evec,&nrot);

/* sort the eigenvalues into descending order and
   reorder the corresponding column eigenvectors*/

eigsrt(eval,evec,4);

/* Calculate rotation matrix */

q1 = evec[1][4];
q2 = evec[2][4];
q3 = evec[3][4];
q4 = evec[4][4];

rot[0][0] = q1*q1 + q2*q2 - q3*q3 -q4*q4;
rot[0][1] = 2.0 * (q2 * q3 + q1 * q4);
rot[0][2] = 2.0 * (q2 * q4 - q1 * q3);

rot[1][0] = 2.0 * (q2 * q3 - q1 * q4);
rot[1][1] = q1*q1 + q3*q3 - q2*q2 - q4*q4;
rot[1][2] = 2.0 * (q3 * q4 + q1 * q2);

rot[2][0] = 2.0 * (q2 * q4 + q1 * q3);
rot[2][1] = 2.0 * (q3 * q4 - q1 * q2);
rot[2][2] = q1*q1 + q4*q4 -q2*q2 - q3*q3;

/* Update coordinates for second FRAGMENT using rotation matrix */

for(i=0;i<no_bestca;i++){

   if((matrix_mult(equiv_ca[1][i],rot,new_ca[i]))!=0){
      fprintf(stderr,"Error in multiplication of rotation matrix");
      fprintf(stderr," in Kearsley algorithm\n");
      exit(1);
   }
   for(j=0;j<3;j++){
      equiv_ca[1][i][j] = new_ca[i][j];
   }
}


/* Update start_ca coordinates for list2 PROTEINS using rotation matrix and

   centroid of first fragment */

for(i=0;i<nlist2;i++){

   for(j=0;j<ren[list2[i]];j++){

      for(k=0;k<3;k++)
	 start_ca[list2[i]][j][k] -= fragment_centroid[1][k];

      if((matrix_mult(start_ca[list2[i]][j],rot,temp_ca[list2[i]][j]))!=0){
	fprintf(stderr,"Error in multiplication of rotation matrix");
	fprintf(stderr," in Kearsley algorithm\n");
	exit(1);
      }

      for(k=0;k<3;k++)
	 start_ca[list2[i]][j][k] = temp_ca[list2[i]][j][k] + fragment_centroid[0][k];

   }
}

/* Update ca coordinates for list2 PROTEINS */

for(i=0;i<nlist2;i++){

   for(j=0;j<ren[list2[i]];j++){

      for(k=0;k<3;k++)
	 total_xyz[i][k] += start_ca[list2[i]][j][k];

   }

   for(k=0;k<3;k++)
      centroid[i][k]=total_xyz[i][k]/(float)ren[list2[i]];
}

for(i=0;i<nlist2;i++){

   for(j=0;j<ren[list2[i]];j++){

      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = start_ca[list2[i]][j][k] - centroid[i][k];
   }
}

/*
   Calculate translation vector of transformation:

   VT = -R * BT + AT
*/


for(i=0;i<3;i++)
   vtrans[i] = -(fragment_centroid[1][i]);

if((matrix_mult(vtrans,rot,temp))!=0){
  fprintf(stderr,"Error in multiplication of rotation matrix");
  fprintf(stderr," in calculating tranlation vector\n");
  exit(1);
}

for(i=0;i<3;i++)
   vtrans[i] = temp[i];

for(i=0;i<3;i++)
   vtrans[i] += fragment_centroid[0][i];


if(total_dist>MAX_DIST){
  fprintf(stderr,"Error in calculating total distance ");
  fprintf(stderr,"in print_align_ca()\n");
  exit(1);
}
else{

   printf("\n\n Summary of structural superposition: ");
   printf("\n ----------------------------------- \n");

   if(gen<=maxgen)
     printf("\n After %d generations :\n",gen);
   else
     printf("\n After %d generations :\n",maxgen);

 if((no_bestca > 0)&&(total_dist > 0.0)){

     rmsd1 = sqrt((total_dist/(double)no_bestca));

     printf("\n The GA global best individual so far number of equivalences");
     printf(" = %d",no_bestca);

     printf("\n The GA global best individual so far rmsd over ");
     printf("%d equivalences =%7.3f",no_bestca,rmsd1);


     /* Calculate Kearsley rmsd between GA-matched CA atoms */

   if(eval[4] >= 0.0){

      rmsd2 = sqrt((double)eval[4]/(double)no_bestca);

      printf("\n Kearsley rmsd between  GA-matched  %d ",no_bestca);
      printf("equivalences = %7.3f",rmsd2);

      if (rmsd2 > 0.0){
	 printf("\n Convergence index = %0.3f\n",
					    (1.0 - ((rmsd1-rmsd2)/rmsd2)));
      }
      else{
	  printf("\n Cannot calculate Convergence index : ");
	  printf("Kearsley rmsd = 0.000\n");
      }

      printf("\n GA-matched topological equivalences after Kearsley (1989) algorithm: ");
      printf("\n -------------------------------------------------------------------\n");

      m=0;
      total_dist=0.0;   /* To update rmsd after Kearsley (1989) algorithm */
      *end_no_bestca=0; /* Equivalences after Kearsley (1989) algorithm */


      last_j = 0;
      last_k = 0;

      /* zero arrays */

      for(i=0; i<nlist1; i++){
	 check1[i] = 0;
	 last_check1[i] = 0;
      }

      for(i=0; i<nlist2; i++){
	 check2[i] = 0;
	 last_check2[i] = 0;
      }


      for(i=0; i<no_bestca; i++){

	 d=distance(equiv_ca[0][i],equiv_ca[1][i]);

	 /* Test for equivalence after Kearsley algorithm */

	 if(d < sqr_cutoff ){

	   total_dist += d;

	   Kears_final_equiv[0][m] = equiv[0][i];
	   Kears_final_equiv[1][m] = equiv[1][i];
	   m++;

	   (*end_no_bestca)++; /* equivalence after Kearsley (1989) algorithm */

	   printf("\n %d		 [",i+1);

	   for(p=last_j; p<(equiv[0][i] + 1); p++){
	      for(q=0; q<nlist1; q++){

		 if(seq[list1[q]][p+1] != '-')
		   check1[q]++;
	      }
	   }

	   last_j = (equiv[0][i] + 1); /* Update */

	   for(q=0; q<nlist1; q++){

	      if(check1[q]<=ren[list1[q]]){

		if(q == (nlist1-1)){
		  if((check1[q]>0) && (check1[q]>last_check1[q]) && (seq[list1[q]][equiv[0][i] + 1] != '-'))
		    printf("%s %s",residue_number[list1[q]][check1[q] - 1],residue_name[list1[q]][check1[q] - 1]);
		  else
		    printf("        ");
		}
		else{
		  if((check1[q]>0) && (check1[q]>last_check1[q]) && (seq[list1[q]][equiv[0][i] + 1] != '-'))
		    printf("%s %s-",residue_number[list1[q]][check1[q] - 1],residue_name[list1[q]][check1[q] - 1]);
		  else
		    printf("        -");
		}
	      }
	      else{

		if(q == (nlist1-1))
		  printf("        ");

		else
		  printf("        -");
	      }

	      last_check1[q] = check1[q]; /* Update */
	   }

	   printf("]");
	   printf("          [");

	   for(p=last_k; p<(equiv[1][i] + 1); p++){
	      for(q=0; q<nlist2; q++){

		 if(seq[list2[q]][p+1] != '-')
		   check2[q]++;
	      }
	   }

	   last_k = (equiv[1][i] + 1); /* Update */

	   for(q=0; q<nlist2; q++){

	      if(check2[q]<=ren[list2[q]]){

		if(q == (nlist2-1)){
		  if((check2[q]>0) && (check2[q]>last_check2[q]) && (seq[list2[q]][equiv[1][i] + 1] != '-'))
		    printf("%s %s",residue_number[list2[q]][check2[q] - 1],residue_name[list2[q]][check2[q] - 1]);
		  else
		    printf("        ");
		}
		else{
		  if((check2[q]>0) && (check2[q]>last_check2[q]) && (seq[list2[q]][equiv[1][i] + 1] != '-'))
		    printf("%s %s-",residue_number[list2[q]][check2[q] - 1],residue_name[list2[q]][check2[q] - 1]);
		  else
		    printf("        -");
		}
	      }
	      else{

		if(q == (nlist2-1))
		  printf("        ");

		else
		  printf("        -");
	      }

	      last_check2[q] = check2[q]; /* Update */
	   }

	   printf("]");
	   printf("            %0.3f",sqrt(d));

	 }
	 else{

	   /* Flag distances now greater than cut-off distance with asterisk */

	   printf("\n %d		 [",i+1);

	   for(p=last_j; p<(equiv[0][i] + 1); p++){
	      for(q=0; q<nlist1; q++){

		 if(seq[list1[q]][p+1] != '-')
		   check1[q]++;
	      }
	   }

	   last_j = (equiv[0][i] + 1); /* Update */

	   for(q=0; q<nlist1; q++){

	      if(check1[q]<=ren[list1[q]]){

		if(q == (nlist1-1)){
		  if((check1[q]>0) && (check1[q]>last_check1[q]) && (seq[list1[q]][equiv[0][i] + 1] != '-'))
		    printf("%s %s",residue_number[list1[q]][check1[q] - 1],residue_name[list1[q]][check1[q] - 1]);
		  else
		    printf("        ");
		}
		else{
		  if((check1[q]>0) && (check1[q]>last_check1[q]) && (seq[list1[q]][equiv[0][i] + 1] != '-'))
		    printf("%s %s-",residue_number[list1[q]][check1[q] - 1],residue_name[list1[q]][check1[q] - 1]);
		  else
		    printf("        -");
		}
	      }
	      else{

		if(q == (nlist1-1))
		  printf("        ");

		else
		  printf("        -");
	      }

	      last_check1[q] = check1[q]; /* Update */
	   }

	   printf("]");
	   printf("          [");

	   for(p=last_k; p<(equiv[1][i] + 1); p++){
	      for(q=0; q<nlist2; q++){

		 if(seq[list2[q]][p+1] != '-')
		   check2[q]++;
	      }
	   }

	   last_k = (equiv[1][i] + 1); /* Update */

	   for(q=0; q<nlist2; q++){

	      if(check2[q]<=ren[list2[q]]){

		if(q == (nlist2-1)){
		  if((check2[q]>0) && (check2[q]>last_check2[q]) && (seq[list2[q]][equiv[1][i] + 1] != '-'))
		    printf("%s %s",residue_number[list2[q]][check2[q] - 1],residue_name[list2[q]][check2[q] - 1]);
		  else
		    printf("        ");
		}
		else{
		  if((check2[q]>0) && (check2[q]>last_check2[q]) && (seq[list2[q]][equiv[1][i] + 1] != '-'))
		    printf("%s %s-",residue_number[list2[q]][check2[q] - 1],residue_name[list2[q]][check2[q] - 1]);
		  else
		    printf("        -");
		}
	      }
	      else{

		if(q == (nlist2-1))
		  printf("        ");

		else
		  printf("        -");
	      }

	      last_check2[q] = check2[q]; /* Update */
	   }

	   printf("]");
	   printf("            %0.3f	*",sqrt(d));
	 }

      }
      printf("\n\n Kearsley rotation matrix :");
      printf("\n ------------------------\n");
      for(i=0;i<3;i++){
	 printf("\n");
	 for(j=0;j<3;j++)
	    printf(" %7.3f",rot[i][j]);
      }
      printf("\n\n Translation vector :");
      printf("\n ------------------\n");
      for(i=0;i<3;i++)
	 printf("\n %7.3f",vtrans[i]);


      printf("\n\n");
      printf("\n The number of equivalences after Kearsley (1989) algorithm = %d",*end_no_bestca);
      printf("\n ----------------------------------------------------------\n\n");

      /* Check whether need to update rmsd after Kearsley (1989) algorithm */

      if(*end_no_bestca != no_bestca){

	if((*end_no_bestca > 0)&&(total_dist > 0.0))
	  rmsd3 = sqrt((total_dist/(double)*end_no_bestca));

	else{
	  fprintf(stderr,"Error in updating rmsd after Kearsley (1989) algorithm\n");
	  exit(1);
	}

	printf("\n The rmsd after Kearsley (1989) algorithm = %7.3f",rmsd3);
	printf("\n ----------------------------------------\n\n");

      }

      printf(" Maximum possible similarity scores:\n");
      printf(" ----------------------------------\n\n");


      printf(" For %d maximum possible equivalences: %d\n",(MIN(no_res1,no_res2)),((MIN(no_res1,no_res2)) * (int)sqr_cutoff));
      printf(" For %d GA-matched equivalences: %d\n",no_bestca,(no_bestca * (int)sqr_cutoff));
      printf(" For %d equivalences after Kearsley (1989) algorithm: %d\n\n",(*end_no_bestca),((*end_no_bestca) * (int)sqr_cutoff));
   }
   else{
       fprintf(stderr,"\n Cannot calculate Kearsley rmsd yet ...\n");
       exit(1);
   }
 }
 else{
     fprintf(stderr,"\n No equivalences yet...\n");
     exit(1);
 }

}

/* free dynamically allocated storage */

free_fmatrix(mat,1,4,1,4);
free_fmatrix(evec,1,4,1,4);
free_vector(eval,1,4);
free_ivector(check1,0, nlist1-1);
free_ivector(last_check1,0, nlist1-1);
free_ivector(check2,0, nlist2-1);
free_ivector(last_check2,0, nlist2-1);



return (no_bestca);
}


/******** Putting it all together...

				    : objfunc()********/

/* Alex May  17-02-94 */

double objfunc(int *string,float ca[MAX_SEQ][(MAX_LEN-52)][3],
	       int list1[MAX_SEQ],int nlist1,int list2[MAX_SEQ],
	       int nlist2,double sqr_cutoff){



double **mat1,**mat2;
int **mat3;

int no_res1,no_res2;

float temp1,temp2;
float dist_range;

float new_ca[MAX_SEQ][(MAX_LEN-52)][3];
float temp_ca[MAX_SEQ][(MAX_LEN-52)][3];

int junk[BIT_POSITIONS];

double rot_x[3][3];
double rot_y[3][3];
double rot_z[3][3];

float trans[3];
double rot_angle[3];
double gap_pen;

double d;
int *check1, *check2;

int i,j,k,l;
double answer;
int no_comp;

/* Dimensions for matrices */

i = max_len(list1,nlist1,len);
j = max_len(list2,nlist2,len);

no_res1 = len[list1[i]];
no_res2 = len[list2[j]];


/* Allocate memory for CA-CA distance matrix */

mat1 = dmatrix(0,(no_res1)-1,0,(no_res2)-1);

/* Allocate memory for CA-CA similarity matrix */

mat2 = dmatrix(0,(no_res1)-1,0,(no_res2)-1);

/* Allocate memory for counter matrix */

mat3 = imatrix(0,(no_res1)-1,0,(no_res2)-1);


/* Maximum displacement along each axis */

temp1 = max_dim(list1,nlist1,largest_dim);
temp2 = max_dim(list2,nlist2,largest_dim);

dist_range = MAX(temp1,temp2);


/* Convert bit string to rotation matrices */

/* Decode each 8-bit code into a real number in the defined range */

    k=0;
    for(i=0;i<24;i+=BIT_POSITIONS){

        for(j=0;j<BIT_POSITIONS;j++)
           junk[j] = string[i+j];

           if(k<3){

	     trans[k] = ((((float)igray(bits2int(junk,BIT_POSITIONS),-1))

				/ 255.0) * dist_range) - (dist_range/2.0);
	     k++;
           }
    }


    k=0;
    for(i=24;i<MAXSTRING - BIT_POSITIONS;i+=BIT_POSITIONS){


       for(j=0;j<BIT_POSITIONS;j++)
          junk[j] = string[i+j];

          if(k<3){

	    rot_angle[k] = (((double)igray(bits2int(junk,BIT_POSITIONS),-1))

			       / 255.0) * (2.0 * PI);
	    k++;
	  }
    }

   /* Gap Penalty */

   for(i=0;i<BIT_POSITIONS;i++)
      junk[i] = string[(MAXSTRING - BIT_POSITIONS) + i];

      gap_pen = (((double)igray(bits2int(junk,BIT_POSITIONS),-1))

			  / 255.0) * MAXGAP;




    

/* Set up rotation matrices */

/* Rx */

/* Initialise...*/

rot_x[0][0]=1.0;
rot_x[0][1]=0.0;
rot_x[0][2]=0.0;
rot_x[1][0]=0.0;
rot_x[2][0]=0.0;

rot_x[1][1]=cos(rot_angle[0]);
rot_x[1][2]=(-1*(sin(rot_angle[0])));
rot_x[2][1]=sin(rot_angle[0]);
rot_x[2][2]=cos(rot_angle[0]);

/* Ry */

/* Initialise...*/

rot_y[0][1]=0.0;
rot_y[1][0]=0.0;
rot_y[1][1]=1.0;
rot_y[1][2]=0.0;
rot_y[2][1]=0.0;

rot_y[0][0]=cos(rot_angle[1]);
rot_y[0][2]=sin(rot_angle[1]);
rot_y[2][0]=(-1*(sin(rot_angle[1])));
rot_y[2][2]=cos(rot_angle[1]);

/* Rz */

/* Initialise...*/

rot_z[0][2]=0.0;
rot_z[1][2]=0.0;
rot_z[2][0]=0.0;
rot_z[2][1]=0.0;
rot_z[2][2]=1.0;

rot_z[0][0]=cos(rot_angle[2]);
rot_z[0][1]=(-1*(sin(rot_angle[2])));
rot_z[1][0]=sin(rot_angle[2]);
rot_z[1][1]=cos(rot_angle[2]);



for(i=0;i<nlist2;i++){

   /* Store each CA coordinate of list2 proteins at start */

   for(j=0;j<ren[list2[i]];j++){

      for(k=0;k<3;k++)
	 temp_ca[i][j][k] = ca[list2[i]][j][k];


      /******** Update coordinates of list2 proteins ********/

      /* Translations along the 3 axes for each CA atom */

      if((translate(ca[list2[i]][j],trans))!=0){
	 fprintf(stderr,"Error in translation\n");
	 exit(1);
      }


      /* Rotation around x-axis */

      if((matrix_mult(ca[list2[i]][j],rot_x,new_ca[list2[i]][j]))!=0){
	fprintf(stderr,"Error in multiplication of rotation matrix");
	fprintf(stderr," around x-axis\n");
	exit(1);
      }
      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = new_ca[list2[i]][j][k];


      /* Rotation around y-axis */

      if((matrix_mult(ca[list2[i]][j],rot_y,new_ca[list2[i]][j]))!=0){
	fprintf(stderr,"Error in multiplication of rotation matrix");
	fprintf(stderr," around y-axis\n");
	exit(1);
      }
      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = new_ca[list2[i]][j][k];


      /* Rotation around z-axis */

      if((matrix_mult(ca[list2[i]][j],rot_z,new_ca[list2[i]][j]))!=0){
	fprintf(stderr,"Error in multiplication of rotation matrix");
	fprintf(stderr," around z-axis\n");
	exit(1);
      }
      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = new_ca[list2[i]][j][k];
   }

}

/* Construct CA-CA distance matrix and similarity matrix
   from all possible inter CA-CA distances */

/* Initialise 3 matrices */

for(i=0;i<no_res1;i++){
    for(j=0;j<no_res2;j++){

       mat1[i][j] = 0.0;
       mat2[i][j] = 0.0;
       mat3[i][j] = 0;
    }
}

/* Allocate memory for checks on lengths */

check1 = ivector(0, nlist1-1);
check2 = ivector(0, nlist2-1);


   for(i=0;i<nlist1;i++){
      check1[i] = 0;

      for(j=0;j<len[list1[i]];j++){

	 if(seq[list1[i]][j+1] != '-'){
	   check1[i]++;

	   if(check1[i] > ren[list1[i]]){
	     fprintf(stderr,"Error : check1 in objfunc()\n");
	     fprintf(stderr,"check1[%d] = %d ren[list1[%d]] = %d \n",i,check1[i],i,ren[list1[i]]);
	     exit(1);
	   }
	 }

	 for(k=0;k<nlist2;k++){
	    check2[k] = 0;

	    for(l=0;l<len[list2[k]];l++){

	       if(seq[list2[k]][l+1] != '-'){
		 check2[k]++;

		 if(check2[k] > ren[list2[k]]){
		   fprintf(stderr,"Error : check2 in objfunc()\n");
		   fprintf(stderr,"check2[%d] = %d ren[list2[%d]] = %d \n",k,check2[k],k,ren[list2[k]]);
		   exit(1);
		 }
	       }

	       if((seq[list1[i]][j+1] != '-') && (seq[list2[k]][l+1] != '-')){

		 d=distance(ca[list1[i]][check1[i] - 1],ca[list2[k]][check2[k] - 1]);

		 mat1[j][l] += d;
		 mat3[j][l] ++; /* increment counter for non-gap vs.
				   non-gap comparison*/
	       }
	    }
	 }
      }
   }


/* Free memory for checks on lengths */

free_ivector(check1,0, nlist1-1);
free_ivector(check2,0, nlist2-1);

/* Average distances and assign similarities */

no_comp = (nlist1 * nlist2);

for(i=0;i<no_res1;i++){
    for(j=0;j<no_res2;j++){

       if(mat3[i][j] != 0){

	 mat1[i][j] /= (double) mat3[i][j];

	 if(mat1[i][j] < sqr_cutoff){

	   mat2[i][j] += (sqr_cutoff - mat1[i][j]);

	   /* Scale similarity according to number of non-gap vs.
	      non-gap comparisons wrt total number of comparisons */

	   mat2[i][j] *= ((double)mat3[i][j]/(double)no_comp);
	 }

       }
       else if((mat1[i][j] !=  0.0) || (mat2[i][j] !=  0.0)){

	      /* Check mat1 and mat2 when mat3 element is zero */

	      fprintf(stderr,"Error : 3 matrices in objfunc()\n");
	      exit(1);
       }
    }
}

/* Produce final CA-CA alignment */

answer=fast_pair_um(no_res1,no_res2,mat2,gap_pen,sqr_cutoff);

/******** Clean up ********/

free_dmatrix(mat1,0,(no_res1)-1,0,(no_res2)-1);
free_dmatrix(mat2,0,(no_res1)-1,0,(no_res2)-1);
free_imatrix(mat3,0,(no_res1)-1,0,(no_res2)-1);

/* Restore CA coordinates of list2 proteins at end */

for(i=0;i<nlist2;i++){

   for(j=0;j<ren[list2[i]];j++){

      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = temp_ca[i][j][k];

   }
}

return (answer);
}


/******** Special case:printing best CA-CA alignment data...

					: print_objfunc()	********/

/* Alex May  13-03-93 */

int print_objfunc(int *string,float ca[MAX_SEQ][(MAX_LEN-52)][3],
		  int list1[MAX_SEQ],int nlist1,int list2[MAX_SEQ],
		  int nlist2,double sqr_cutoff,double *score1,
		  double *score2,int *align_len,int *end_no_equiv,
		  int mat,int pen){


double **mat1,**mat2;
int **mat3;

int no_res1,no_res2;

float temp1,temp2;
float dist_range;

float new_ca[MAX_SEQ][(MAX_LEN-52)][3];
float temp_ca[MAX_SEQ][(MAX_LEN-52)][3];

int junk[BIT_POSITIONS];


double rot_x[3][3];
double rot_y[3][3];
double rot_z[3][3];

float trans[3];
double rot_angle[3];
double gap_pen;
double last_gap_pen;
double best_gap_pen;
int best_align_len;

double d;
int *check1, *check2;

int i,j,k,l,m;
int answer;
int Kears_end_no_equiv;
int best_no_equiv;
double end_rmsd;
double best_rmsd;
double best_score;
float align_score;
int total_align_score;
float select_score;
float best_select_score;
int common_no_equiv;
int no_comp;


/* Dimensions for matrices */

i = max_len(list1,nlist1,len);
j = max_len(list2,nlist2,len);

no_res1 = len[list1[i]];
no_res2 = len[list2[j]];


/* Allocate memory for CA-CA distance matrix */

mat1=dmatrix(0,(no_res1)-1,0,(no_res2)-1);

/* Allocate memory for CA-CA similarity matrix */

mat2=dmatrix(0,(no_res1)-1,0,(no_res2)-1);

/* Allocate memory for counter matrix */

mat3 = imatrix(0,(no_res1)-1,0,(no_res2)-1);


/* Maximum displacement along each axis */

temp1 = max_dim(list1,nlist1,largest_dim);
temp2 = max_dim(list2,nlist2,largest_dim);

dist_range = MAX(temp1,temp2);

printf(" Maximum translation of 2nd fragment along each axis = ");
printf("%0.3f to %0.3f\n\n",(-0.5 * dist_range),(0.5 * dist_range));



/* Convert bit string to rotation matrices */

/* Decode each 8-bit code into a real number in the defined range */


    k=0;
    for(i=0;i<24;i+=BIT_POSITIONS){

        for(j=0;j<BIT_POSITIONS;j++)
           junk[j] = string[i+j];

           if(k<3){

	     trans[k] = ((((float)igray(bits2int(junk,BIT_POSITIONS),-1))

				/ 255.0) * dist_range) - (dist_range/2.0);
	     k++;
           }
    }


    k=0;
    for(i=24;i<MAXSTRING - BIT_POSITIONS;i+=BIT_POSITIONS){


       for(j=0;j<BIT_POSITIONS;j++)
          junk[j] = string[i+j];

          if(k<3){

	    rot_angle[k] = (((double)igray(bits2int(junk,BIT_POSITIONS),-1))

			       / 255.0) * (2.0 * PI);
	    k++;
	  }
    }

   /* Gap Penalty */

   for(i=0;i<BIT_POSITIONS;i++)
      junk[i] = string[(MAXSTRING - BIT_POSITIONS) + i];

      gap_pen = (((double)igray(bits2int(junk,BIT_POSITIONS),-1))

			  / 255.0) * MAXGAP;


/* Set up rotation matrices */

/* Rx */

/* Initialise...*/

rot_x[0][0]=1.0;
rot_x[0][1]=0.0;
rot_x[0][2]=0.0;
rot_x[1][0]=0.0;
rot_x[2][0]=0.0;

rot_x[1][1]=cos(rot_angle[0]);
rot_x[1][2]=(-1*(sin(rot_angle[0])));
rot_x[2][1]=sin(rot_angle[0]);
rot_x[2][2]=cos(rot_angle[0]);

/* Ry */

/* Initialise...*/

rot_y[0][1]=0.0;
rot_y[1][0]=0.0;
rot_y[1][1]=1.0;
rot_y[1][2]=0.0;
rot_y[2][1]=0.0;

rot_y[0][0]=cos(rot_angle[1]);
rot_y[0][2]=sin(rot_angle[1]);
rot_y[2][0]=(-1*(sin(rot_angle[1])));
rot_y[2][2]=cos(rot_angle[1]);

/* Rz */

/* Initialise...*/

rot_z[0][2]=0.0;
rot_z[1][2]=0.0;
rot_z[2][0]=0.0;
rot_z[2][1]=0.0;
rot_z[2][2]=1.0;

rot_z[0][0]=cos(rot_angle[2]);
rot_z[0][1]=(-1*(sin(rot_angle[2])));
rot_z[1][0]=sin(rot_angle[2]);
rot_z[1][1]=cos(rot_angle[2]);



for(i=0;i<nlist2;i++){

   /* Store each CA coordinate of list2 proteins at start */

   for(j=0;j<ren[list2[i]];j++){

      for(k=0;k<3;k++)
	 temp_ca[i][j][k] = ca[list2[i]][j][k];


      /******** Update coordinates of list2 proteins ********/

      /* Translations along the 3 axes for each CA atom */

      if((translate(ca[list2[i]][j],trans))!=0){
	 fprintf(stderr,"Error in translation\n");
	 exit(1);
      }


      /* Rotation around x-axis */

      if((matrix_mult(ca[list2[i]][j],rot_x,new_ca[list2[i]][j]))!=0){
	fprintf(stderr,"Error in multiplication of rotation matrix");
	fprintf(stderr," around x-axis\n");
	exit(1);
      }
      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = new_ca[list2[i]][j][k];


      /* Rotation around y-axis */

      if((matrix_mult(ca[list2[i]][j],rot_y,new_ca[list2[i]][j]))!=0){
	fprintf(stderr,"Error in multiplication of rotation matrix");
	fprintf(stderr," around y-axis\n");
	exit(1);
      }
      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = new_ca[list2[i]][j][k];


      /* Rotation around z-axis */

      if((matrix_mult(ca[list2[i]][j],rot_z,new_ca[list2[i]][j]))!=0){
	fprintf(stderr,"Error in multiplication of rotation matrix");
	fprintf(stderr," around z-axis\n");
	exit(1);
      }
      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = new_ca[list2[i]][j][k];
   }

}

/* Construct CA-CA distance matrix and similarity matrix
   from all possible inter CA-CA distances */

/* Initialise 3 matrices */

for(i=0;i<no_res1;i++){
    for(j=0;j<no_res2;j++){

       mat1[i][j] = 0.0;
       mat2[i][j] = 0.0;
       mat3[i][j] = 0;
    }
}

/* Allocate memory for checks on lengths */

check1 = ivector(0, nlist1-1);
check2 = ivector(0, nlist2-1);


   for(i=0;i<nlist1;i++){
      check1[i] = 0;

      for(j=0;j<len[list1[i]];j++){

	 if(seq[list1[i]][j+1] != '-'){
	   check1[i]++;

	   if(check1[i] > ren[list1[i]]){
	     fprintf(stderr,"Error : check1 in print_objfunc()\n");
	     fprintf(stderr,"check1[%d] = %d ren[list1[%d]] = %d \n",i,check1[i],i,ren[list1[i]]);
	     exit(1);
	   }
	 }

	 for(k=0;k<nlist2;k++){
	    check2[k] = 0;

	    for(l=0;l<len[list2[k]];l++){

	       if(seq[list2[k]][l+1] != '-'){
		 check2[k]++;

		 if(check2[k] > ren[list2[k]]){
		   fprintf(stderr,"Error : check2 in print_objfunc()\n");
		   fprintf(stderr,"check2[%d] = %d ren[list2[%d]] = %d \n",k,check2[k],k,ren[list2[k]]);
		   exit(1);
		 }
	       }

	       if((seq[list1[i]][j+1] != '-') && (seq[list2[k]][l+1] != '-')){

		 d=distance(ca[list1[i]][check1[i] - 1],ca[list2[k]][check2[k] - 1]);

		 mat1[j][l] += d;
		 mat3[j][l] ++; /* increment counter for non-gap vs.
				   non-gap comparison*/
	       }
	    }
	 }
      }
   }

/* Average distances and assign similarities */

no_comp = (nlist1 * nlist2);

for(i=0;i<no_res1;i++){
    for(j=0;j<no_res2;j++){

       if(mat3[i][j] != 0){

	 mat1[i][j] /= (double) mat3[i][j];

	 if(mat1[i][j] < sqr_cutoff){

	   mat2[i][j] += (sqr_cutoff - mat1[i][j]);

	   /* Scale similarity according to number of non-gap vs.
	      non-gap comparisons wrt total number of comparisons */

	   mat2[i][j] *= ((double)mat3[i][j]/(double)no_comp);
	 }

       }
       else if((mat1[i][j] !=  0.0) || (mat2[i][j] !=  0.0)){

	      /* Check mat1 and mat2 when mat3 element is zero */

	      fprintf(stderr,"Error : 3 matrices in print_objfunc()\n");
	      exit(1);
       }
    }
}

/* Restore CA coordinates of list2 proteins at end */

for(i=0;i<nlist2;i++){

   for(j=0;j<ren[list2[i]];j++){

      for(k=0;k<3;k++)
	 ca[list2[i]][j][k] = temp_ca[i][j][k];

   }
}

/* Print GA best translations,rotation angles and gap penalty */

printf("\n\n The GA global best translation along x-axis = %0.3f\n",trans[0]);

printf(" The GA global best translation along y-axis = %0.3f\n",trans[1]);

printf(" The GA global best translation along z-axis = %0.3f\n",trans[2]);

printf(" The GA global best rotation angle about x-axis = %0.3f\n",
						  (rot_angle[0]*(180.0/PI)));
printf(" The GA global best rotation angle about y-axis = %0.3f\n",
						  (rot_angle[1]*(180.0/PI)));
printf(" The GA global best rotation angle about z-axis = %0.3f\n",
						  (rot_angle[2]*(180.0/PI)));

printf(" The GA global best length-independent gap penalty = %0.3f\n\n",gap_pen);


/* Produce best CA-CA alignment */

*score1 = (-99.0);
*score1 = ga_pair_um(no_res1,no_res2,mat2,align_len,gap_pen);

if(*score1 == (-99.0)){
  fprintf(stderr,"Error in producing the GA global best global alignment\n");
  exit(1);
}

/* Print best CA-CA alignment data */

answer = print_align_ca(no_res1,no_res2,list1,nlist1,list2,nlist2,mat1,*align_len,sqr_cutoff,&Kears_end_no_equiv);

/* Construct CA-CA distance matrix and similarity matrix
   from all possible inter CA-CA distances after Kearsley (1989)
   least-squares fitting */

/* Initialise 3 matrices */

for(i=0;i<no_res1;i++){
    for(j=0;j<no_res2;j++){

       mat1[i][j] = 0.0;
       mat2[i][j] = 0.0;
       mat3[i][j] = 0;
    }
}

   for(i=0;i<nlist1;i++){
      check1[i] = 0;

      for(j=0;j<len[list1[i]];j++){

	 if(seq[list1[i]][j+1] != '-'){
	   check1[i]++;

	   if(check1[i] > ren[list1[i]]){
	     fprintf(stderr,"Error : check1 in print_objfunc()\n");
	     fprintf(stderr,"check1[%d] = %d ren[list1[%d]] = %d \n",i,check1[i],i,ren[list1[i]]);
	     exit(1);
	   }
	 }

	 for(k=0;k<nlist2;k++){
	    check2[k] = 0;

	    for(l=0;l<len[list2[k]];l++){

	       if(seq[list2[k]][l+1] != '-'){
		 check2[k]++;

		 if(check2[k] > ren[list2[k]]){
		   fprintf(stderr,"Error : check2 in print_objfunc()\n");
		   fprintf(stderr,"check2[%d] = %d ren[list2[%d]] = %d \n",k,check2[k],k,ren[list2[k]]);
		   exit(1);
		 }
	       }

	       if((seq[list1[i]][j+1] != '-') && (seq[list2[k]][l+1] != '-')){

		 d=distance(start_ca[list1[i]][check1[i] - 1],start_ca[list2[k]][check2[k] - 1]);

		 mat1[j][l] += d;
		 mat3[j][l] ++; /* increment counter for non-gap vs.
				   non-gap comparison*/
	       }
	    }
	 }
      }
   }

/* Average distances and assign similarities */

for(i=0;i<no_res1;i++){
    for(j=0;j<no_res2;j++){

       if(mat3[i][j] != 0){

	 mat1[i][j] /= (double) mat3[i][j];

	 if(mat1[i][j] < sqr_cutoff){

	   mat2[i][j] += (sqr_cutoff - mat1[i][j]);

	   /* Scale similarity according to number of non-gap vs.
	      non-gap comparisons wrt total number of comparisons */

	   mat2[i][j] *= ((double)mat3[i][j]/(double)no_comp);
	 }

       }
       else if((mat1[i][j] !=  0.0) || (mat2[i][j] !=  0.0)){

	      /* Check mat1 and mat2 when mat3 element is zero */

	      fprintf(stderr,"Error : 3 matrices in print_objfunc()\n");
	      exit(1);
       }
    }
}
printf("\n\n");
printf(" Gap penalty Sim.score No.equivs rmsd Align.length Align.score Common equivs\n");
printf(" ----------- --------- --------- ---- ------------ ----------- -------------\n");

for(m=0;m<11;m++){

 /* Assign Gap Penalty */

 last_gap_pen = ((double)m/10.0) * sqr_cutoff;

 /* Produce CA-CA alignment after Kearsley (1989) least-squares fitting */

 *score2 = (-99.0);
 *score2 = ga_pair_um(no_res1,no_res2,mat2,align_len,last_gap_pen);

 if(*score2 == (-99.0)){
   fprintf(stderr,"Error in producing CA-CA alignment after Kearsley (1989) algorithm");
   fprintf(stderr," when gap penalty = %0.1f\n",last_gap_pen);
   exit(1);
 }

 /* Update equivalences and rmsd */

 if((update_align_ca(no_res1,no_res2,mat1,*align_len,sqr_cutoff,end_no_equiv,&end_rmsd,last_gap_pen))!=0){
   fprintf(stderr,"Error in updating equivalences and rmsd when gap penalty = %0.1f\n",last_gap_pen);
   exit(1);
 }

 /* Use a scoring matrix to evaluate alternative sequence alignments:
    score per alignment position */

 total_align_score=0;
 k=0;

 for(i=0;i<nlist1;i++){

    for(j=0;j<nlist2;j++){

	 total_align_score += score_um(list1[i],list2[j],*align_len,mat,pen,1);
	 k++;
    }
 }

 if(k == (nlist1 * nlist2)){

   if((k>0) && (*align_len > 0)){
     align_score = (float)total_align_score/(float)k;
     align_score /= (float)*align_len;
   }
   else{
     fprintf(stderr,"Error1 in evaluation of alternative sequence alignments when gap penalty = %0.1f\n",last_gap_pen);
     exit(1);
   }
 }
 else{
   fprintf(stderr,"Error2 in evaluation of alternative sequence alignments when gap penalty = %0.1f\n",last_gap_pen);
   exit(1);
 }

 /* Common equivalences with those after Kearsley (1989) algorithm */

 common_no_equiv = comp_equiv(Kears_end_no_equiv,Kears_final_equiv,*end_no_equiv,final_equiv);

 /* Select score for alignment */

 select_score = align_score;

 /* Print statistics after Kearsley (1989) least-squares fitting */

 printf("     %0.1f       %d        %d     %0.3f    %d         %0.3f         %d\n",
 last_gap_pen,(int)*score2,*end_no_equiv,end_rmsd,*align_len,align_score,common_no_equiv);

 if(m == 0){

   best_gap_pen = last_gap_pen;
   best_score = *score2;
   best_no_equiv = *end_no_equiv;
   best_rmsd = end_rmsd;
   best_align_len = *align_len;
   best_select_score = select_score;
 }

 else if(select_score >= best_select_score){

   best_gap_pen = last_gap_pen;
   best_score = *score2;
   best_no_equiv = *end_no_equiv;
   best_rmsd = end_rmsd;
   best_align_len = *align_len;
   best_select_score = select_score;
 }
}

/* Produce best CA-CA alignment after Kearsley (1989) least-squares fitting */

 *score2 = (-99.0);
 *score2 = ga_pair_um(no_res1,no_res2,mat2,align_len,best_gap_pen);

 if(*score2 == (-99.0)){
   fprintf(stderr,"Error in producing CA-CA alignment after Kearsley (1989) algorithm");
   fprintf(stderr," when gap penalty = %0.1f\n",best_gap_pen);
   exit(1);
 }

 /* Check score */

 if(*score2 != best_score){
   fprintf(stderr,"Error in score for best CA-CA alignment\n");
   exit(1);
 }

 /* Update equivalences and rmsd */

 if((update_align_ca(no_res1,no_res2,mat1,*align_len,sqr_cutoff,end_no_equiv,&end_rmsd,best_gap_pen))!=0){
   fprintf(stderr,"Error in updating equivalences and rmsd when gap penalty = %0.1f\n",best_gap_pen);
   exit(1);
 }

 /* Check equivalences */

 if(*end_no_equiv != best_no_equiv){
   fprintf(stderr,"Error in equivalences for best CA-CA alignment\n");
   exit(1);
 }

 /* Check rmsd */

 if(end_rmsd != best_rmsd){
   fprintf(stderr,"Error in rmsd for best CA-CA alignment\n");
   exit(1);
 }

 /* Check length of alignment */

 if(*align_len != best_align_len){
   fprintf(stderr,"Error in length of alignment for best CA-CA alignment\n");
   exit(1);
 }

 /* Print best CA-CA alignment after Kearsley (1989) least-squares fitting */

 printf("\n\n");
 printf(" The best Fredman (1984) global alignment after Kearsley (1989) algorithm:\n");
 printf(" ------------------------------------------------------------------------\n");

 printf(" Length-independent gap penalty = %0.1f\n",best_gap_pen);
 printf(" Similarity score = %d\n",(int)best_score);
 printf(" Number of equivalences = %d\trmsd = %7.3f\n",best_no_equiv,best_rmsd);

 if((best_no_equiv > 0)&&(best_rmsd >= 0.0))
   printf(" Ratio:\trmsd/number of equivalences = %7.3f\n",(best_rmsd/(double)best_no_equiv));

 else{
   fprintf(stderr,"Error in ratio:\trmsd/number of equivalences for best CA-CA alignment\n");
   fprintf(stderr,"best_no_equiv = %d\tbest_rmsd = %0.3f\n",best_no_equiv,best_rmsd);
   exit(1);
 }

/******** Clean up ********/

free_dmatrix(mat1,0,(no_res1)-1,0,(no_res2)-1);
free_dmatrix(mat2,0,(no_res1)-1,0,(no_res2)-1);
free_imatrix(mat3,0,(no_res1)-1,0,(no_res2)-1);

/* Free memory for checks on lengths */

free_ivector(check1,0, nlist1-1);
free_ivector(check2,0, nlist2-1);

return (answer);
}




