#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "external.h"



#define MAX_NAME 25
#define MAX_CDE 25
#define MAX_TIT  50

extern char pdb_filename[MAX_SEQ][MAX_NAME];	/* array of PDB filenames */
extern char code[MAX_SEQ][MAX_CDE];
extern char title[MAX_SEQ][MAX_TIT];
extern char seq[MAX_SEQ][MAX_LEN];
extern float largest_dim[MAX_SEQ];
extern int len[MAX_SEQ];
extern int ren[MAX_SEQ];


char compnd_rec[MAX_TIT];
struct atom_rec atom;

int read_um(file)

FILE *file;


{

char line[90];
register int i,j;
register int flag;

register int no_struc;                  /* number of PDB structures */
float total_xyz[MAX_SEQ][3] = {0.0};
float centroid[MAX_SEQ][3];

float max_x,max_y,max_z;
float min_x,min_y,min_z;
float dx,dy,dz;



FILE *fp;


printf("\n\nStructures: ");



/* Read list of PDB files */

no_struc=0;

while(fscanf(file,"%s",&pdb_filename[no_struc])!=EOF){

/* note that I have removed the requirement for a 4 letter code + .pdb
 * for the Brookhaven file name MSJ 8-8-96
 */

/*
    if(strncmp(line+5,"pdb",3)!=0)
      continue;

    else{
      sscanf(line,"%8s",pdb_filename[no_struc]);
      pdb_filename[no_struc][8]='\0';
*/

      /* Code */

      strcpy(code[no_struc],pdb_filename[no_struc]);
/*
      code[no_struc][4]='\0';
*/

      no_struc++;

    if (no_struc == MAX_SEQ ) {
       fprintf( stderr, "Too many PDB files !!\n");
       break;
    }
}
fprintf(stdout," read in %d filenames\n",no_struc);

printf("\n      Code                      Title     ");
printf("                        Length\n");

fclose(file);

/* Open and read each PDB file */

for(i=0; i<no_struc; i++){

  len[i]=0;
  flag = 0;

  printf("\n[%3d] %-10.10s ",i+1,code[i]);

  if((fp=fopen(pdb_filename[i],"r"))==NULL){
      fprintf(stderr,"File \"%s\" cannot be opened",pdb_filename[i]);
      perror(pdb_filename[i]);
      exit(1);
  }

  /* MSJ needs first position as a space */

  seq[i][len[i]] = ' ';


	while (fgets(line,90,fp)) {

	      /* Title */

	      if ((read_Brookhaven_COMPND_record( line ) != -1) && (flag == 0)){

		 strcpy(title[i],compnd_rec);
		 printf("%-50.50s",title[i]);
		 flag = 1;
	      }

	      if (read_Brookhaven_ATOM_record( line ) != -1) {

		 if (strcmp( atom.atom_name, "CA " ) == 0) {

		     total_xyz[i][0] += ca[i][len[i]][0] = atom.xyz[0];
		     total_xyz[i][1] += ca[i][len[i]][1] = atom.xyz[1];
		     total_xyz[i][2] += ca[i][len[i]][2] = atom.xyz[2];

		     strcpy(residue_name[i][len[i]],atom.residue_name);

		     strcpy(residue_number[i][len[i]],atom.residue_number);

		     seq[i][len[i] + 1] = three_let_to_1let(atom.residue_name);

		     if(seq[i][len[i] + 1] == NULL) {
		       fprintf(stderr,"Amino acid name not recognized");
		       fprintf(stderr," in structure %d\n",i);
		       exit(1);
		     }

		     if(len[i] == 0){ /* First residue */

			max_x = min_x = ca[i][len[i]][0];
			max_y = min_y = ca[i][len[i]][1];
			max_z = min_z = ca[i][len[i]][2];
		     }
		     else{

			if(ca[i][len[i]][0] > max_x)
			  max_x = ca[i][len[i]][0];

			if(ca[i][len[i]][1] > max_y)
			  max_y = ca[i][len[i]][1];

			if(ca[i][len[i]][2] > max_z)
			  max_z = ca[i][len[i]][2];

			if(ca[i][len[i]][0] < min_x)
			  min_x = ca[i][len[i]][0];

			if(ca[i][len[i]][1] < min_y)
			  min_y = ca[i][len[i]][1];

			if(ca[i][len[i]][2] < min_z)
			  min_z = ca[i][len[i]][2];
		     }

		     len[i]++;
		 }

	      }

              if (len[i] == (MAX_LEN-52) ) {
                 fprintf( stderr, "Too many residues in PDB file %s\n", pdb_filename[i]);
		 break;
              }

	}

	if(flag == 0){ /* No title in PDB file */

	  strcpy(title[i],"No molecule name");
	  printf("%-50.50s",title[i]);

	}

	seq[i][len[i] + 1] = '\0';

	centroid[i][0]=total_xyz[i][0]/(float)len[i];
	centroid[i][1]=total_xyz[i][1]/(float)len[i];
	centroid[i][2]=total_xyz[i][2]/(float)len[i];

	/* Close each PDB file */

	fclose(fp);

	/* Dimensions of each molecule */

	if(max_x > 0.0)
	   dx = max_x - min_x;

	else
	   dx = max_x + fabs(min_x);

	if(max_y > 0.0)
	   dy = max_y - min_y;

	else
	   dy = max_y + fabs(min_y);

	if(max_z > 0.0)
	   dz = max_z - min_z;

	else
	   dz = max_z + fabs(min_z);

	/* Largest single dimension for each molecule */

	largest_dim[i] = MAX(dx,dy);

	if(largest_dim[i] < dz)
	  largest_dim[i] = dz;


	/* Translate centroid of each molecule to the origin of
	   the coordinate system */


	for(j=0;j<len[i];j++){

		start_ca[i][j][0] = ca[i][j][0];
		ca[i][j][0]-=centroid[i][0];

                start_ca[i][j][1] = ca[i][j][1];
		ca[i][j][1]-=centroid[i][1];

		start_ca[i][j][2] = ca[i][j][2];
		ca[i][j][2]-=centroid[i][2];
	}

	printf(" %d",len[i]);

	ren[i] = len[i];
}

return(no_struc);

}

