/*
 *		      TREE_UM.C  MS Johnson  24-06-1990
 *
 *			     Copyright (c) 1990
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	Multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *	This tree constructing program mainly written by MSJ at UCSD 1980s
 *
 */


#include <stdio.h>
#include "external.h"

#define MAX_CDE 25

extern char code[MAX_SEQ][MAX_CDE];
extern float fscore[MAX_SEQ][MAX_SEQ];
extern int family[MAX_SEQ][MAX_SEQ];
extern int matrix[MAX_LEN][MAX_LEN];
extern int r_f, p_f, m_f;
extern int mf_flag;

float pro[MAX_SEQ][MAX_SEQ];
int score;
double alt_score;
int end_no_equiv;


int lenj,lenk;
int list1[MAX_SEQ];
int list2[MAX_SEQ];
int nlist1,nlist2;
int tt_len;

void comp_um();
int pair_um();
void print_um();
void copy_um();

void tree_um(ns,mat,pen,t_len)
int ns;
int mat;
int pen;
int *t_len;
{
int i,j,k,qz,side,ss1,v,zt,zz,Z;
int minj1,mink1;

side = 0;
i=1;
qz=1;
i=0;
Z=0;
for(j=1;j<ns;++j)
	{
	for(k=j+1;k<=ns;++k)
		{
		pro[j][k]=fscore[j-1][k-1];
		pro[k][j]=fscore[j-1][k-1];
		}
	}
FINDMIN(&minj1, &mink1,ns);
zt=1;
ss1=ns-1;
pro[mink1][minj1]=1000;
pro[minj1][mink1]=1000;
family[0][0]=minj1;
family[0][1]=mink1;

/*
 *	compare 1st pair
 */

printf("\n\n\n**************************************************************************");
printf("\n****** Starting multiple alignment following tree construction ... *******");
printf("\n**************************************************************************");

/*
 *	first pair; therefor cycle once only
 */

m_f=0;

list1[0]=minj1-1;
nlist1=1;
list2[0]=mink1-1;
nlist2=1;

/*
 *	make the alignment
 */

score = ga_fit(list1,nlist1,list2,nlist2,&alt_score,&end_no_equiv,mat,pen,&tt_len);
*t_len=tt_len;

/*
 *	printout the alignment
 */

printf("\n_______________________________");
printf("___________________________________________\n\n");
printf("Cluster: [%s %s]",code[minj1-1],code[mink1-1]);
printf("\nSimilarity score after Genetic algorithm: %d",(int)alt_score);
printf("\nSimilarity score after Kearsley (1989) algorithm: %d\n",score);

print_um(list1,nlist1,list2,nlist2,tt_len,end_no_equiv);

/*
 *	replace seq records with alignment; alter len[] to t_len
 */

copy_um(list1,nlist1,list2,nlist2,tt_len);

for(zz=1;zz<=ss1;++zz)
	{
	if(zz== ss1-1 && zt==1)mf_flag=1;
	NEWMATRIX(ns);
	FINDMIN(&minj1, &mink1,ns);
	FAMFIND(&Z,&ss1,minj1,mink1,mat,pen,&tt_len);
	*t_len=tt_len;
	if(family[qz][0]!=0)
		{
		zz--;
		qz++;
		}
	if(zz== ss1-1 && zt==1)
		goto rat2;
	}
rat2:;
fflush(stdout);

printf("\n\n\n");
printf("Branching order: ");
for(i=0;i<=Z;++i)
	{
	if(side==1) printf("\nSub    Clusters: ");
	else if(side>1)printf("\nSub    Clusters: ");

	printf("[%s %s] ",code[family[i][0]-1],code[family[i][1]-1]);

	for(v=2;family[i][v]!=0;++v)
		{
		printf("%s] ",code[family[i][v]-1]);
		if(v%5==0 && ns>5)printf("\n                  ");
		}
	side++;
	}
printf("\n");


return;
}

FINDMIN(pminj1,pmink1,ns)
int *pminj1, *pmink1;
int ns;
{
int j,k;

j=1;
k=2;
*pminj1 = j;
*pmink1 = k;
while(j<ns)
	{
	while(k<ns)
		{
		if(pro[*pminj1][*pmink1] > pro[j][++k])
			{
			*pminj1 = j;
			*pmink1 = k;
			}
		else 
			continue;
		}
	++j;
	k=j;
	}
return;
}

NEWMATRIX(ns)
int ns;
{
int i,j,k,q,qq1,qq2;

j=1;
k=2;
while(j<ns)
	{
	while(k<=ns)
		{
		for(i=0;family[i][0]!=0;++i)
			{
			for(q=0;family[i][q]!=0;q++)
				{
				if(pro[j][k]==1000) goto NEWK;
				else if(j==family[i][q])
					{
					qq1=k;
					qq2=j;
					AV(qq1,qq2,i);
					goto NEWK;
					}
				else if(k==family[i][q])
					{
					qq1=j;
					qq2=k;
					AV(qq1,qq2,i);
					goto NEWK;
					}
				else continue;
				}
			}
	 	NEWK:;
		++k;
		}
	j++;
	k=j+1;
	}
return;
}

FAMFIND(pZ,pss1,minj1,mink1,mat,pen,t_len)
int *pZ, *pss1, minj1, mink1,mat,pen;
int *t_len;
{
  /*Will detect whether the pair with the*/
  /*minimum value belongs to any other family*/

int i,q,q1,W;

for(i=0;family[i][0]!=0;++i)
	{
  	for(q=0;family[i][q]!=0;++q)
		{
    		if(family[i][q]==minj1)
			{
			q1=mink1;
			OTHER(q1,i,mat,pen,&t_len);
			goto tree;
			}
    		if(family[i][q]==mink1)
			{
			q1=minj1;
			OTHER(q1,i,mat,pen,&t_len);
			goto tree;
			}
    		}
	}
(*pZ)++;
if(W=1)W=0;
		/*A new pair to be placed into a new family*/

pro[minj1][mink1]=1000;
pro[mink1][minj1]=1000;
family[*pZ][0]=minj1;
family[*pZ][1]=mink1;

/*
 *	make nodal comparison here
 */

m_f=0;

list1[0]=minj1-1;
nlist1=1;
list2[0]=mink1-1;
nlist2=1;

/*
 *	make the alignment
 */

score = ga_fit(list1,nlist1,list2,nlist2,&alt_score,&end_no_equiv,mat,pen,&tt_len);
*t_len=tt_len;

/*
 *	printout the alignment
 */


printf("\n_______________________________");
printf("___________________________________________\n\n");
printf("Cluster: [%s %s]",code[minj1-1],code[mink1-1]);
printf("\nSimilarity score after Genetic algorithm: %d",(int)alt_score);
printf("\nSimilarity score after Kearsley (1989) algorithm: %d\n",score);

print_um(list1,nlist1,list2,nlist2,tt_len,end_no_equiv);

/*
 *	replace seq records with alignment; alter len[] to t_len
 */

copy_um(list1,nlist1,list2,nlist2,tt_len);

W++;
if(W==1) (*pss1)--;
tree: return;
}

OTHER(q1,i,mat,pen,t_len)
int q1,i,mat,pen;
int *t_len;
{
	/*Checks to see if the other min. value belongs*/
	/*to another family*/
int ii,ii1,v,vv,tr;

for(ii=0;family[ii][0]!=0;ii++)
	{
	for(ii1=0;family[ii][ii1]!=0;++ii1)
		{
		if(q1==family[ii][ii1])
			{
			ANOTHER(&ii,i,mat,pen,&t_len);
			return;
			}
		}
	}

/*Does not belong to a new family*/

for(v=0;v<MAX_SEQ;++v)
	{
	if(family[i][v]==0)
		{
		family[i][v]=q1;

		/* make comparison with template */

		printf("\n_______________________________");
		printf("___________________________________________\n\n");

		m_f=1;

		for(tr=0;tr<v;tr++)
			{
			list1[tr]=family[i][tr]-1;
			}
		nlist1=v;
		list2[0]=q1-1;
		nlist2=1;
		printf("Cluster: [");
		for(tr=0;tr<v-1;tr++)printf("%s ",code[list1[tr]]);
		printf("%s]",code[list1[tr]]);
		printf("\nCluster: [");
		printf("%s]",code[list2[0]]);

		score = ga_fit(list1,nlist1,list2,nlist2,&alt_score,&end_no_equiv,mat,pen,&tt_len);
		*t_len=tt_len;

/*
 *	replace seq records with alignment; alter len[] to t_len
 */

		printf("\nSimilarity score after Genetic algorithm: %d",(int)alt_score);
		printf("\nSimilarity score after Kearsley (1989) algorithm: %d\n",score);

		print_um(list1,nlist1,list2,nlist2,tt_len,end_no_equiv);

		copy_um(list1,nlist1,list2,nlist2,tt_len);

		break;
		}
	}
for(v=0;family[i][v+1]!=0;++v)
	{
	for(vv=1;family[i][vv]!=0;++vv)
		{
		if(family[i][v]!=family[i][vv])
			{
			pro[family[i][v]][family[i][vv]]=1000;
			pro[family[i][vv]][family[i][v]]=1000;
			}
		}
	}
return;
}

ANOTHER(pii,i,mat,pen,t_len)
int *pii, i,mat,pen;
int *t_len;
{
      /*Min. does belong to another family...add to*/
      /*family of first min. value*/
int v,vv,vs1,tr1,tr2;

for(v=0;v<MAX_SEQ;v++)
	{
	if(family[i][v]==0)
		{
		vs1=v;
		for(vv=0;family[*pii][vv]!=0;++vv)
			family[i][v++]=family[*pii][vv];

		printf("\n_______________________________");
		printf("___________________________________________\n\n");

		m_f=1;

		for(tr1=0;tr1<vs1;tr1++)
			{
			for(tr2=vs1;tr2<v;tr2++)
				{
			list1[tr1]=family[i][tr1]-1;
			list2[tr2-vs1]=family[i][tr2]-1;
				}
			}
		nlist1=vs1;
		nlist2=v-vs1;
		printf("Cluster: [");
		for(tr1=0;tr1<nlist1-1;tr1++)printf("%s ",code[list1[tr1]]);
		printf("%s]",code[list1[tr1]]);
		printf("\nCluster: [");
		for(tr2=0;tr2<nlist2-1;tr2++)printf("%s ",code[list2[tr2]]);
		printf("%s]",code[list2[tr2]]);

		score = ga_fit(list1,nlist1,list2,nlist2,&alt_score,&end_no_equiv,mat,pen,&tt_len);
		*t_len=tt_len;

/*
 *	replace seq records with alignment; alter len[] to t_len
 */
		printf("\nSimilarity score after Genetic algorithm: %d",(int)alt_score);
		printf("\nSimilarity score after Kearsley (1989) algorithm: %d\n",score);

		print_um(list1,nlist1,list2,nlist2,tt_len,end_no_equiv);

		copy_um(list1,nlist1,list2,nlist2,tt_len);

		break;
		}
	}
for(v=0;family[i][v+1]!=0;v++)
	{
	for(vv=1;family[i][vv]!=0;++vv)
		{
		if(family[i][v]!=family[i][vv])
			{
			pro[family[i][v]][family[i][vv]]=1000;
			pro[family[i][vv]][family[i][v]]=1000;
			}
		}
	}
return;
}

AV(qq1,qq2,i)
int qq1,qq2,i;
{
 /*Determines whether qq1 also belongs to a*/
 /*family; if so, average throughout both families*/

int ii,ii1,m,n,q,v;

m=n=v=0;
pro[m][n]=0;
for(ii=0;family[ii][0]!=0;++ii)
	{
	for(ii1=0;family[ii][ii1]!=0;++ii1)
		{
		if(qq1==family[ii][ii1])
			goto heman;
		else continue;
		}
	}
for(q=0;family[i][q]!=0;++q)
	{
	++v;
	pro[m][n] += fscore[family[i][q]-1][qq1-1];
	}
pro[m][n]/=v;
pro[qq1][qq2]=pro[m][n];
pro[qq2][qq1]=pro[m][n];
goto heman2;

    /*qq1 belongs to a separate family average*/
    /*thoughout both families*/

heman:	for(ii1=0;family[ii][ii1]!=0;ii1++)
		{
		for(q=0;family[i][q]!=0;++q)
			{
			v++;
			pro[m][n] += fscore[family[i][q]-1][family[ii][ii1]-1];
			}
		}
	pro[m][n]=pro[m][n]/v;
	for(ii1=0;family[ii][ii1]!=0;++ii1)
		{
		for(q=0;family[i][q]!=0;++q)
			{
			pro[family[ii][ii1]][family[i][q]]=pro[m][n];
			pro[family[i][q]][family[ii][ii1]]=pro[m][n];
			}
		}

heman2: return;
}
