#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "external.h"

extern int final_equiv[2][(MAX_LEN-52)];

int update_align_ca(int no_res1,int no_res2,double **mat1,int len,
		    double sqr_cutoff,int *no_equiv,double *rmsd,
		    double gap_pen){

int i,j,k;
int no_ca=0;
double total_dist=0.0;

*no_equiv=0;

for(i=len-1;i>=0;i--){

   /* Test for no gap in protein 1 */

   if(align[0][i]!=(-99))
     j = align[0][i];

     /* Test for no gap in protein 2 */

     if(align[1][i]!=(-99))
       k = align[1][i];

       /* Test for corresponding atoms in protein 1 and 2 */

       if((align[0][i]!=(-99)) && (align[1][i]!=(-99))){

	   if((no_ca<=no_res1)&&(no_ca<=no_res2))
	     no_ca++;

	   else{
	     fprintf(stderr,"Error in update_align_ca():\tno_ca=%d\n",no_ca);
	     exit(1);
	   }

	    /* Test for defined distance apart */

	    /* j-1,k-1 because mat1 is 0 to len-1 */

	    if((mat1[j-1][k-1] < sqr_cutoff )&&(*no_equiv<=no_ca)){

	      total_dist+=mat1[j-1][k-1];

	      final_equiv[0][*no_equiv] = (j-1);
	      final_equiv[1][*no_equiv] = (k-1);

	      (*no_equiv)++; /* Equivalence */

	      if(*no_equiv>=(MAX_LEN-52)){
		fprintf(stderr,"Too many equivalences!!\n");
	        exit(1);
	      }
	    }
       }
}

if(total_dist>MAX_DIST){
  fprintf(stderr,"Error in calculating total distance ");
  fprintf(stderr,"in update_align_ca()\n");
  exit(1);
}
else{

 if((*no_equiv > 0)&&(total_dist >= 0.0))
   *rmsd = sqrt((total_dist/(double)*no_equiv));

 else{
   printf("\nNo equivalences when gap penalty = %0.3f\n",gap_pen);
   *no_equiv=(-99);
   *rmsd=(-99.0);
 }

}

return 0;
}

int comp_equiv(int no_equiv1,int equiv1[2][(MAX_LEN-52)],int no_equiv2,int equiv2[2][(MAX_LEN-52)]){

int common_no_equiv;
int i,j,k;

j=0;
common_no_equiv=0;


	for(i=0;i<no_equiv2;i++){

	   if(j == no_equiv1)
	     break;

	   if(equiv2[0][i] == equiv1[0][j]){

	     if(equiv2[1][i] == equiv1[1][j])
	       common_no_equiv++;

	     j++;
	   }
	   else{

	       for(k=j;k<no_equiv1;k++){

		  if(equiv2[0][i] == equiv1[0][k]){

		    if(equiv2[1][i] == equiv1[1][k])
		      common_no_equiv++;

		    j=(++k);
		    break;
		  }
	       }
	   }
	}

return common_no_equiv;
}