/*
 *		      PRINT_UM.C  MS Johnson  26-06-1990
 *
 *			     Copyright (c) 1990
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *
 *
 */

#include <ctype.h>
#include "external.h"

#define MAX_CDE	25
#define MAX_TIT 50
#define MAX_WID 75

extern char seq[MAX_SEQ][MAX_LEN];
extern char code[MAX_SEQ][MAX_CDE];
extern char title[MAX_SEQ][MAX_TIT];
extern int temp[2][MAX_LEN];
extern int mf_flag;			/* intermediate =0; final =1 */
extern int final_equiv[2][(MAX_LEN-52)];



void print_um(list1,nlist1,list2,nlist2,t_len,end_no_equiv)

int list1[MAX_SEQ],nlist1;
int list2[MAX_SEQ],nlist2;
int t_len;
int end_no_equiv;

{
register int i,j,k,m;

/*
 *	output the pairwise alignments
 */

if(mf_flag==0)printf("\n~");
else printf("\n^");


k=0;

for(i=0;i<nlist1;i++)
	{
	m=0;

	printf("\n>P1;%s",code[list1[i]]);
	printf("\n%s",title[list1[i]]);
	printf("\n");
	for(j=1;j<=t_len;j++)
		{
		if(temp[0][j]== -99)printf("-");
		else{

		 if((temp[0][j]-1 == final_equiv[k][m]) && (m < end_no_equiv)){

		   /* equivalence after Kearsley (1989) algorithm */

		   printf("%c",seq[list1[i]][temp[0][j]]);
		   m++;
		 }
		 else
		   printf("%c",tolower(seq[list1[i]][temp[0][j]]));
		}
		if(j>1 && j%MAX_WID==0)printf("\n");
		}
	if(j>1 && j%MAX_WID==0)printf("\n");
	printf("*");
	}
k=1;

for(i=0;i<nlist2;i++)
	{
	m=0;

	printf("\n>P1;%s",code[list2[i]]);
	printf("\n%s",title[list2[i]]);
	printf("\n");
	for(j=1;j<=t_len;j++)
		{
		if(temp[1][j]== -99)printf("-");
		else{

		 if((temp[1][j]-1 == final_equiv[k][m]) && (m < end_no_equiv)){

		   /* equivalence after Kearsley (1989) algorithm */

		   printf("%c",seq[list2[i]][temp[1][j]]);
		   m++;
		 }
		 else
		   printf("%c",tolower(seq[list2[i]][temp[1][j]]));
		}
		if(j>1 && j%MAX_WID==0)printf("\n");
		}
	if(j>1 && j%MAX_WID==0)printf("\n");
	printf("*");
	}
if(mf_flag==0)printf("\n~");
else printf("\n^");
printf("\n");

return;
}
