/*

  To extract equivalences common to all structures in a multiple alignment
  by MULTI_GA_FIT. Print in PIR format.


  Alex May 13 October 1994


*/

#include <ctype.h>
#include "external.h"

#define MAX_CDE	25
#define MAX_TIT 50
#define MAX_WID 75

extern char seq[MAX_SEQ][MAX_LEN];
extern char code[MAX_SEQ][MAX_CDE];
extern char title[MAX_SEQ][MAX_TIT];
extern int family[MAX_SEQ][MAX_SEQ];


int print_common_equiv(int t_len,
		       int no_struc,
		       const int *all_equiv){

register int threshold;
register int sum_all_equiv;

register int i,j;


threshold = (SQR(no_struc) - no_struc)/2.0;
sum_all_equiv = 0;

for(i=0;i<no_struc;i++){

   printf("\n>P1;%s",code[family[0][i]-1]);
   printf("\n%s",title[family[0][i]-1]);
   printf("\n");

   for(j=1;j<=t_len;j++){

      if(all_equiv[j-1] == threshold){
	printf("%c",seq[family[0][i]-1][j]);

	if(i == 0)
	  sum_all_equiv++;
      }

      else
	printf(" ");

      if(j>1 && j%MAX_WID==0)printf("\n");
   }

   if(j>1 && j%MAX_WID==0)printf("\n");
   printf("*");
}

printf("\n\n");

return(sum_all_equiv);
}
