/*
 *		      SCORE_UM.C  MS Johnson  26-06-1990
 *
 *			     Copyright (c) 1990
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *
 *
 */

#include "external.h"

extern char seq[MAX_SEQ][MAX_LEN];
extern int temp[2][MAX_LEN];
extern int mats[11][20][20];
extern int ind[26];

char t_seq[2][MAX_LEN];			/* alignment minus gaps in common */

int score_um(i,j,t_len,mat,pen,type)

int i,j;
int t_len;
int mat;
int pen;
int type;
{
register int k,l;

int n_len;				/* length of align minus common gps */
int gp, oh;				/* mark ohang and gaps */
int score;				/* alignment score - raw */

/*
 *	if type == 0 then sequence aligned by pair_um is located in seq[][];
 *	else the sequence alignment is numerical and located in temp[][];
 */

if(type==0)
	{

	/*
	 *	score given matrix and gap penalties
	 */

	n_len=0;

	/*
	 *	remove gaps held in common from mult alignment
	 */

	l=1;

	for(k=1;k<=t_len;k++)
		{

		/*
		 *	gap in both: ignore;
		 */

		if(seq[i][k]== '-' && seq[j][k]== '-');
		else	{
			t_seq[0][l]=seq[i][k];
			t_seq[1][l]=seq[j][k];
			l++;
			n_len++;
			}
		}

	/*
	 *	cycle through reduced sequences
	 */

	oh=0;
	gp=0;
	score=0;

	for(k=1;k<=n_len;k++)
		{

		/*
		 *	gap in one; check for overhang
		 */

		if(t_seq[0][k]== '-')
			{
			/* check for overhang at c-term */

			if(gp==1 && k==n_len)score += pen;
			else if(k==n_len);
			else if(gp==1);
			else if(oh==1);
			else if(k==1)oh=1; /* ohang starts at position 0 */
			else	{
				gp=1;
				score -= pen;
				}
			}
		

		else if(t_seq[1][k]== '-')
			{
			/* check for overhang at c-term */

			if(gp==1 && k==n_len)score += pen;
			else if(k==n_len);
			else if(gp==1);
			else if(oh==1);
			else if(k==1)oh=1; /* ohang starts at position 0 */
			else	{
				gp=1;
				score -= pen;
				}
			}
		
		else	{
			gp=0;
			oh=0;
			score+=
			mats[mat][ind[t_seq[0][k]-'A']][ind[t_seq[1][k]-'A']];
			}
		}
   	}

else	{

	/*
	 *	score given matrix and gap penalties
	 */

	n_len=0;

	/*
	 *	remove gaps held in common from mult alignment
	 */

	l=1;

	for(k=1;k<=t_len;k++)
		{

		/*
		 *	gap in both: ignore;
		 */

		if(temp[0][k]== -99 && temp[1][k]== -99);
		else if(temp[0][k]== -99 && seq[j][temp[1][k]]== '-');
		else if(temp[1][k]== -99 && seq[i][temp[0][k]]== '-');
		else if(temp[0][k]== -99)
			{
			t_seq[0][l]= '-';
			t_seq[1][l]= seq[j][temp[1][k]];
			l++;
			n_len++;
			}
		else if(temp[1][k]== -99)
			{
			t_seq[0][l]= seq[i][temp[0][k]];
			t_seq[1][l]= '-';
			l++;
			n_len++;
			}
		else	{
			t_seq[0][l]=seq[i][temp[0][k]];
			t_seq[1][l]=seq[j][temp[1][k]];
			l++;
			n_len++;
			}
		}

	/*
	 *	cycle through reduced sequences
	 */

	oh=0;
	gp=0;
	score=0;

	for(k=1;k<=n_len;k++)
		{

		/*
		 *	gap in one; check for overhang
		 */

		if(t_seq[0][k]== '-')
			{
			/* check for overhang at c-term */
	
			if(gp==1 && k==n_len)score += pen;
			else if(k==n_len);
			else if(gp==1);
			else if(oh==1);
			else if(k==1)oh=1; /* ohang starts at position 0 */
			else	{
				gp=1;
				score -= pen;
				}
			}
		

		else if(t_seq[1][k]== '-')
			{
			/* check for overhang at c-term */

			if(gp==1 && k==n_len)score += pen;
			else if(k==n_len);
			else if(gp==1);
			else if(oh==1);
			else if(k==1)oh=1; /* ohang starts at position 0 */
			else	{
				gp=1;
				score -= pen;
				}
			}
		
		else	{
			gp=0;
			oh=0;
			score+=
			mats[mat][ind[t_seq[0][k]-'A']][ind[t_seq[1][k]-'A']];
			}
		}
   	}

return(score);
}
